
# TYPE  DATABASE        USER            ADDRESS                 METHOD
local   all             postgres                                trust
local   all             all                                     trust
host    all             all             127.0.0.1/32            trust
host    all             all             ::1/128                 trust
local   replication     all                                     peer
host    replication     all             127.0.0.1/32            scram-sha-256
host    replication     all             ::1/128                 scram-sha-256

{% if postgresql_create_db %}  {# Проверяем, нужно ли создавать БД #}
    # Allow connections from application hosts
    {% if postgresql_ansible_app_group != "" %}  {# Проверяем, задана ли группа хостов в Ansible #}
        {% for client in groups[postgresql_ansible_app_group] %}  {# Перебираем хосты из группы #}
            {% if hostvars[client].ansible_host != "" %}  {# Проверяем, есть ли у клиента ansible_host #}
                {% for db in postgresql_databases %}  {# Перебираем базы данных #}
                    {% for user in postgresql_users %}  {# Перебираем пользователей #}
                        {% if user.db == db.name %}  {# Если пользователь привязан к базе, добавляем правило #}

host  {{ db.name }}  {{ user.name }}  {{ hostvars[client].ansible_host }}/32  {{ postgresql_db_auth_method }}
                        {% endif %}
                    {% endfor %}  {# Конец цикла по пользователям #}
                {% endfor %}  {# Конец цикла по базам данных #}
            {% endif %}  {# Конец проверки наличия ansible_host #}
        {% endfor %}  {# Конец цикла по хостам группы #}
    {% elif postgresql_clients_addresses != [] %}  {# Если группа хостов не задана, но есть список IP #}
        {% for client in postgresql_clients_addresses %}  {# Перебираем список IP клиентов #}
            {% for db in postgresql_databases %}  {# Перебираем базы данных #}
                {% for user in postgresql_users %}  {# Перебираем пользователей #}
                    {% if user.db == db.name %}  {# Если пользователь привязан к базе, добавляем правило #}

host  {{ db.name }}  {{ user.name }}  {{ client }}  {{ postgresql_db_auth_method }}
                    {% endif %}
                {% endfor %}  {# Конец цикла по пользователям #}
            {% endfor %}  {# Конец цикла по базам данных #}
        {% endfor %}  {# Конец цикла по IP-адресам #}
    {% endif %}  {# Конец проверки на группу хостов и список IP #}
{% endif %}  {# Конец проверки на создание БД #}
{% if postgresql_users_replic is defined and postgresql_users_replic %}
    {% for host in groups[group_servers_postgres] %}
        {% if (hostvars[host]['postgresql_master_bool'] is defined and hostvars[host]['postgresql_master_bool']) or (hostvars[host]['postgresql_slave_bool'] is defined and hostvars[host]['postgresql_slave_bool']) %}

host replication {{ postgresql_users_replic[0].name }} {{ hostvars[host]['ansible_host'] }}/32 md5
        {% else %}
# Хост {{ host }} не является мастером или слейвом (postgresql_master_bool=false, postgresql_slave_bool=false)
    {% endif %}
{% endfor %}
{% else %}
# Переменная postgresql_users_replic пуста или не определена
{% endif %}